
//------------------------
//--  Declare varaibles
//------------------------
var 
//--- 15 Endogenous variables
Y C K I Ia Itht 
W R Lam 
N Na Ntht
G Ga Theta
//--- 1 axullary variables
MU
//--- 1 variables appearing in shock pricesses
Xi_shock;

varexo etemp;

//--------------------------
//--  Declare parameters
//--------------------------
parameters
//--- calibrated parameters
epsl del alp gama alpa phia gamtht 
alptht phitht ntt nlb beta
//--- shock parameters
rho_xi
;
load initvalue.mat
//--------------------------------------------------------------------
//-- Model specification
//--------------------------------------------------------------------
model;
//(1)
Lam = beta*C(-1)/C/G(-1);

//(2)
K*G = K(-1)*(1-del) + I;

//(3)
Lam(1)*(R(1) + 1 - del) = 1;

//(4)
Y = K(-1)^alp*N^(1-alp);

//(5)
(1-alp)*Y = epsl/Theta/(epsl/Theta - 1)*W*N;

//(6)
alp*Y = epsl/Theta/(epsl/Theta - 1)*R*K(-1);

//(7)
Theta = (epsl/alptht/Xi_shock)^(alptht*Xi_shock/(alptht*Xi_shock-1))
    *(1/gamtht*(ntt-Na)^(-phitht*Xi_shock))^(1/(alptht*Xi_shock-1));

//(8)
1/alpa*(Ga/Na^phia/gama)^(1/alpa) = Lam(1)*(Theta/epsl/(epsl-1)
    + 1/alpa*(Ga(1)/Na(1)^phia/gama)^(1/alpa));

//(9) 
phia/alpa*(Ga/Na^phia/gama)^(1/alpa)/Na = 
phitht/alptht*(Theta/(ntt-Na)^(phitht*Xi_shock)/gamtht)^(1/alptht/Xi_shock)/(ntt-Na);

//(10)
Na + Ntht = ntt;

//(11)
N = nlb + etemp;

//(12)
Ia/Y = (Ga/gama/Na^phia)^(1/alpa);

//(13)
Itht/Y = (Theta/gamtht/(ntt-Na)^(phia*Xi_shock))^(1/alpa/Xi_shock);

//(14)
Y = C + I + Ia + Itht;

//(15)
G = Ga^(1/(epsl-1)/(1-alp));

//(16)
MU = epsl/Theta/(epsl/Theta-1);

//(17)
//Xi_shock-STEADY_STATE(Xi_shock)=rho_xi*(Xi_shock(-1)-STEADY_STATE(Xi_shock)) + (1-rho_xi)*0;
Xi_shock-STEADY_STATE(Xi_shock)=0;
end;

initval;
Y        = yy_end(1);
C        = yy_end(2);
K        = yy_end(3);
I        = yy_end(4);
Ia       = yy_end(5);
Itht     = yy_end(6);
W        = yy_end(7);
R        = yy_end(8);
Lam      = yy_end(9);
N        = yy_end(10);
Na       = yy_end(11);
Ntht     = yy_end(12);
G        = yy_end(13);
Ga       = yy_end(14);
Theta    = yy_end(15);
MU       = yy_end(16);
Xi_shock = yy_end(17);
end;



steady;
check;

shocks;
var etemp;
periods 1;
values (0.1);
end;

endval;
Y        = yy_end(1);
C        = yy_end(2);
K        = yy_end(3);
I        = yy_end(4);
Ia       = yy_end(5);
Itht     = yy_end(6);
W        = yy_end(7);
R        = yy_end(8);
Lam      = yy_end(9);
N        = yy_end(10);
Na       = yy_end(11);
Ntht     = yy_end(12);
G        = yy_end(13);
Ga       = yy_end(14);
Theta    = yy_end(15);
MU       = yy_end(16);
Xi_shock = yy_end(17);
end;

perfect_foresight_setup(periods=400);
perfect_foresight_solver;
//simul(periods=400);